#!/usr/local/bin/perl
###############################################################################
#    				mysqlwdb
#
#    This is a cgi script written in Perl5, easy to configure and to install,
#    intended to manage MySQL database tables through a web interface.
#    Just edit and configure THIS UNIQUE file.
#
###############################################################################
###############################################################################
#
#    Copyright (C) 2000 Andrea Maestrutti http://www.solution4web.com/mysqlwdb
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License version 2 as 
#    published by the Free Software Foundation.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
#    You may also find the license at http://www.gnu.org/copyleft/gpl.html
#
###############################################################################

#==============================================================================================
#
#				VARIABLE CONFIGURATION SECTION
#
#		PLEASE READ THE INSTALLATION DOCUMENT AND CHANGE UNDER THIS COMMENT THE 
#		VARIABLES YOU NEED, TO REFLECT TO YOUR PURPOSES
#
#==============================================================================================


#=============================================
#	Name of this CGI script
#=============================================
$thiscgi=		'mysqlwdb.pl';


#=============================================
#	DB & user variables
#=============================================
$host=			'! C H A N G E   T H I S !';
$database=		'! C H A N G E   T H I S !';
$user=			'! C H A N G E   T H I S !';
$passwd=		'! C H A N G E   T H I S !';


#=============================================
#	MySQL specific variable
#=============================================
$mysql_specific=	1;	# 1 means YES, 0 means NO


#=============================================
#	DBI variables
#=============================================
$DBI_driver=		'mysql';
$dsn=			"DBI:$DBI_driver:database=$database;host=$host";
		
			# or "DBI:$DBI_driver:$database:$host" for older DBD::mysql


#=============================================
#	DBMS actions	
#=============================================

# 1 means YES, 0 means NO

$drop_enabled=		1;	# to be able to drop table(s)
$drop_check=		1;	# to be prompted before drop table(s)
$delete_enabled=	1;	# to be able to delete field(s)
$delete_check=		1;	# to be prompted before delete field(s)
$select_enabled=	1;	# to be able to select field(s)
$edititem_enabled=	1;	# to be able to edit field(s) for update
$new_enabled=		1;	# to be able to edit fields for create new record(s)
$prepare_enabled=	1;	# to be able to prepare select on checked field(s)
$describe_enabled=	1;	# to be able to describe table(s)
$selectfields_enabled=	1;	# to be able to select checked field(s)
$insertrecord_enabled=	1;	# to be able to insert records(s)
$insertrecord_check=	1;	# to be prompted before insert record(s)
$updaterecord_enabled=	1;	# to be able to update field(s)
$updaterecord_check=	1;	# to be prompted before update table(s)
$refresh_enabled=	1;	# to be able to refresh table(s) list
$max_selected_rows=	500;	# to provide an overall limit to the number of ALL selected records


#=============================================
#	Delimitator	
#=============================================
$delimitator=		'@@';


#=============================================
#	javascript
#=============================================

$javascript_enabled=	1;	# 1 means that javascript code will check whether tables/records/fields
				# have been correctly checked or not


#=============================================
#	HTML interface variables	
#=============================================

#=======font_face

$font_face=	 	'Verdana, Arial, Helvetica, sans-serif';	# font for general text
$button_font_face=	'Verdana, Arial, Helvetica, sans-serif';	# font for buttons
$numb_table_checkb_ff=	'Verdana, Arial, Helvetica, sans-serif';	# font for numbers before the checkbox of tables
$numb_rec_checkb_ff=	'Verdana, Arial, Helvetica, sans-serif';	# font for numbers before the checkbox of records
$tablename_font_face=	'Verdana, Arial, Helvetica, sans-serif';	# font for tables names

#=======font_size

$font_size= 		'2';	# font size for general text
$button_font_size=	'2';	# font size for buttons
$numb_table_checkb_fs=	'2';	# font size for numbers before the checkbox of tables
$numb_rec_checkb_fs=	'2';	# font size for numbers before the checkbox of records
$tablename_font_size=	'2';	# font size for tables names

#=======colors

$font_color= 		'#000000';	# color font for general text
$button_font_color=	'#000000';	# color for buttons
$table_color= 		'#f0f0f0';	# color for tables
$table_td_color=	'#a0b8c8';	# color for tables columns
$tablename_font_color=	'#000000';	# color font for tables names
$table_checkb_td_color=	'#a0b8c8';	# color for columns with the checkbox of tables
$numb_table_checkb_col=	'#000000';	# color font for numbers before the checkbox of tables
$numb_rec_checkb_col=	'#000000';	# color font for numbers before the checkbox of records
$rec_checkb_td_color=	'#a0b8c8';	# color for columns with the checkbox of records
$pri_key_color=		'#ea6467';	# color for columns with primary key fields
$field_color=		'#00b8c8';	# color for columns with records fields
$label_color=		'#ea6467';	# color for labels

#=======form

$input_text_size=	15;	# text size of the input control for insert & update fields
$textarea_enabled=	1;	# 1 means YES, 0 means NO
$max_length4text=	40; 	# if the number of characters of the field is higher than $max_length4text,
				# a textarea appears (if enabled) instead of the input control
$cols_textarea=		35;	# number of columns of the textarea
$rows_textarea=		4;	# number of rows of the textarea
$where_text_size=	10;	# text size of input control for the SQL where

$limit_values=		q{
			<option>5
			<option>10
			<option>25
			<option>50
			<option>100
			};

$select_params=		q{
			<option>like
			<option>&gt;
			<option>&gt;=
			<option>&lt;
			<option>&lt;=
			};

$new_values=		q{
			<option>1
			<option>2
			<option>3
			<option>4
			<option>5
			<option>10
			<option>20
			};


#=============================================
#	HTML header & footer	
#=============================================

$HTML_header=		qq{

<html>
<head>
<title>$thiscgi - $database management</title>
</head>
<body bgcolor="#FFFFFF">
<br>
<center>
<table border=0 cellpadding=1 cellspacing=0 width = "90%">
<tr><td bgcolor="#000000">
<table border=0 cellpadding=5 cellspacing=0 width = "100%">
<tr><td bgcolor = "#f0f0f0" width="100%">
<font face= "Arial, Helvetica" size="+1">
$thiscgi
</font>
</td>
<td bgcolor="#f0f0f0" align="right" nowrap>
<font face="Arial, Helvetica" size="+1">
$database
</font>
</td>
</tr>
</table>
</td></tr>
</table>
</center>
			};


$HTML_footer=		q{	

</body>
</html>
			};


#==============================================================================================
#				VARIABLE CONFIGURATION SECTION END
#==============================================================================================

#==============================================================================================
#
#					PAY ATTENTION!
#
#	PLEASE DO NOT EDIT ANYTHING UNDER THIS COMMENT IF YOU ARE NOT SURE WHAT ARE YOU DOING
#
#==============================================================================================


#===============================================#
#						#
#	   	     main			#
#						#
#===============================================#

&DBI_initialization;
&input_from_CGI;
&put_HTTP_header;

print $HTML_header;

&get_action_info;
&perform_action;

print $HTML_footer;
exit;

#===============================================#
#						#
#	   	subroutines			#
#						#
#===============================================#

#===============================================
#	HTTP & CGI & DBI subroutines
#===============================================

sub put_HTTP_header {

	print "Content-Type: text/html\r\n\r\n";
}


sub input_from_CGI {

	if ($ENV{REQUEST_METHOD} eq "GET") {
		
		$request=$ENV{QUERY_STRING};
		
	} else {
		
		read( STDIN, $request, $ENV{CONTENT_LENGTH} );
	}

        @pair = split( '&', $request );

	foreach $elem ( @pair ) {

        	( $name, $value ) = split( '=', $elem );

        	$value   =~ tr/+/ /;

        	$name   =~ s/%([A-Fa-f0-9][A-Fa-f0-9])/pack('c',hex($1))/ge;
        	$value =~ s/%([A-Fa-f0-9][A-Fa-f0-9])/pack('c',hex($1))/ge;

	       	$CGI_INPUT{$name} = $value;
	}
}


sub DBI_initialization {

	use DBI;

	if (!($dbh=DBI->connect($dsn,$user,$passwd))) {
		
		&put_HTTP_header;
	 	print $HTML_header;
	 	$err="<b>ERROR:</b> Can not connect to the database<br><b>details:</b> $DBI::errstr";
		&write_labeled_message($err);
		print $HTML_footer;
		exit;
	}

}


#===============================================
#	Misc. subroutines
#===============================================


sub write_labeled_message {

	print qq{<br><br><center>
		<table border="0" cellspacing="1" cellpadding="3" width="300">
		<TR bgcolor="$label_color" align="center"><TD><FONT FACE="$font_face" size="$font_size">};

	print $_[0];
			
	print q{</font></TD></TR>
		</TABLE></center>};
}


sub numerically { $a <=> $b; }


sub html2txt {
	
	my $html_input=$_[0];
	my $param=$_[1];

	$html_input =~ s/&/&amp;/g;
	$html_input =~ s/</&lt;/g;
	$html_input =~ s/>/&gt;/g;
	$html_input =~ s/"/&quot;/g;
	
	if ($param eq 'br') {
		$html_input =~ s/\n/<br>/g;
	}

	return $html_input;
}


sub txt2html {
	
	my $html_input=$_[0];
	my $param=$_[1];

	if ($param eq 'br') {
		$html_input =~ s/<br>/\n/g;
	}
	
	$html_input =~ s/&quot;/"/g;
	$html_input =~ s/&gt;/>/g;
	$html_input =~ s/&lt;/</g;
	$html_input =~ s/&amp;/&/g;

	return $html_input;
}


#===============================================
#	DBMS actions subroutines
#===============================================


sub drop {

	my ($table_name,
	    $warning_flag,
	    $err_message
	    );

	foreach $table_name (keys %CHECKED_TABLES) {

		$sth =                      
		  $dbh->do( "drop table $table_name");
 	                  
		if ( !defined $sth ) {
			$global_err="$DBI::errstr";
			return 0;
		 		
		} elsif ($sth eq "0E0") {
				
			$warning_flag=1;
		}
	}

	if ($warning_flag) {
		
		$err_message=q{<b>WARNING</b>: '0 rows affected' happened};
		&write_labeled_message($err_message);
	}
	
	return 1;
}


sub delete {

	my ($key_value,
	    $table_name,
	    $key_name,
	    $delete_string,
	    $number,
	    $warning_flag,
	    $err_message
	    );

	if (!&lock_tables) {return 0;}

	foreach $table_name (keys %CHECKED_ITEMS) {

		foreach $key_name (keys %{$CHECKED_ITEMS{$table_name}}) {

			foreach $number (keys %{$CHECKED_ITEMS{$table_name}{$key_name}}) {

				$key_value=$dbh->quote($CHECKED_ITEMS{$table_name}{$key_name}{$number});
				$key_value=~s/%/\\%/g;
				$key_value=~s/_/\\_/g;

				$delete_string=qq{delete from $table_name where ($key_name like $key_value)};

				$sth =                      
				  $dbh->do( "$delete_string");
 	                  
				if ( !defined $sth ) {
					$global_err="$DBI::errstr";
					return 0;
		 		
		 		} elsif ($sth eq "0E0") {
				
					$warning_flag=1;
				}
			}
		}
	}

	if (!&unlock_tables) {
		
		return 0;
	
	} else {
		
		if ($warning_flag) {
			
			$err_message=q{<b>WARNING</b>: '0 rows affected' happened};
			&write_labeled_message($global_err);
		}
		
		return 1;
	}
}


sub describe {

	my $table_name;
	
	$table_name=$_[0];

	$sth =                      
	  $dbh->prepare( "describe $table_name");

	if ( !defined $sth ) {
		$global_err="$DBI::errstr";
		return 0;
	}

	$sth->execute;
	
	$descarray_describe=$sth->{NAME};
	
	$elem_describe=$sth->fetchall_arrayref;
	
	$sth->finish;
	
	return 1;
}


sub select {

	my $select_string;
	   
	$select_string=$_[0];
	
	$sth =                      
	  $dbh->prepare( "$select_string");
 	                  
	if ( !defined $sth ) {
		$global_err="$DBI::errstr";
		return 0;
	}

	$sth->execute;
	
	$descarray=$sth->{NAME};
	
	$elem_select=$sth->fetchall_arrayref;
	
	$sth->finish;
	
	return 1;
}


sub get_pri_key {

	my ($table_name,
	    $key_index,
	    $refbool
	    );

	$table_name=$_[0];

	if ($mysql_specific) {

		$sth =                      
		  $dbh->prepare( "LISTFIELDS $table_name");
 	                  
		if ( !defined $sth ) {
			$global_err="$DBI::errstr";
			return 0;
		}

		$sth->execute;
	
		$descarray=$sth->{'NAME'};
		
		$refbool=$sth->{'is_pri_key'};

		$sth->finish;
			
		foreach $key_index (0..$#{$refbool}) {

			if ($refbool->[$key_index] eq 1) {
			
				return $descarray->[$key_index],$key_index;
			}
		}
	
	} else {
	
		#I don't know how implement this feature
	}
	
	return 0;
}


sub prepare {

	my $table_name;
	
	$table_name=$_[0];

	if ($mysql_specific) {

		$sth =                      
		  $dbh->prepare( "LISTFIELDS $table_name");
 	                  
		if ( !defined $sth ) {
			$global_err="$DBI::errstr";
			return 0;
		}

		$sth->execute;
	
		$descarray=$sth->{'NAME'};
		
		$sth->finish;
	
	} else {
	
		$sth =                      
	 	  $dbh->prepare( "select * from $table_name");
 	                  
		if ( !defined $sth ) {
			$global_err="$DBI::errstr";
			return 0;
		}

		$sth->execute;
	
		$descarray=$sth->{NAME};
	
		$sth->finish;
	}
	
	@{$PREPARE_NAMES{$table_name}}=@{$descarray};
	
	return 1;
}


sub update_records {

	my ($set_string,
	    $where_string,
	    $update_string,
	    $quoted_value,
	    $table_name,
	    $key_name,
	    $number,
	    $field_name,
	    $field_value,
	    $warning_flag
	    );

	if (!&lock_tables) {return 0;}

	foreach $table_name (keys %CHECKED_ITEMS) {

		foreach $key_name (keys %{$CHECKED_ITEMS{$table_name}}) {
			
			foreach $number (keys %{$CHECKED_ITEMS{$table_name}{$key_name}}) {

				$quoted_value=$dbh->quote($CHECKED_ITEMS{$table_name}{$key_name}{$number});
				$quoted_value=~s/%/\\%/g;
				$quoted_value=~s/_/\\_/g;

				$where_string='where ('.$key_name.' like '.$quoted_value.')';
				
				$set_string='';

				foreach $field_name (keys %{$FIELD_VALUES{$table_name}{$number}}) {

					$field_value=$FIELD_VALUES{$table_name}{$number}{$field_name};
						
					if ($updaterecord_check) {
							
						&txt2html($field_value,'nobr');
					}
					
					$field_value=$dbh->quote($field_value);
	
					$set_string.=$field_name.'='.$field_value.',';
				}
				
				chop($set_string);
		
				$update_string='update '.$table_name.' set '.$set_string.' '.$where_string;
			
				$sth =                      
				  $dbh->do( "$update_string");
 	                  
				if ( !defined $sth ) {
					$global_err="$DBI::errstr";
					return 0;
		 		
		 		} elsif ($sth eq "0E0") {
				
					$warning_flag=1;
				}
			}
		}
	}

	if (!&unlock_tables) {
		
		return 0;
	
	} else {
		
		if ($warning_flag) {
			
			$err_message=q{<b>WARNING</b>: '0 rows affected' happened};
			&write_labeled_message($err_message);
		}
		
		return 1;
	}
}


sub insert_records {

	my ($table_name,
	    $field_name,
	    $field_value,
	    $number,
	    $names_string,
	    $values_string,
	    $insert_string,
	    $warning_flag,
	    $err_message
	    );
	
	if (!&lock_tables) {return 0;}
	
	foreach $table_name (keys %FIELD_VALUES) {
		
		foreach $number (sort numerically keys %{$FIELD_VALUES{$table_name}}) {

			$names_string='';
			$values_string='';
			
			foreach $field_name (keys %{$FIELD_VALUES{$table_name}{$number}}) {
				
				$field_value=$FIELD_VALUES{$table_name}{$number}{$field_name};

				if ($insertrecord_check) {
							
					&txt2html($field_value,'nobr');
				}
				
				$field_value=$dbh->quote($field_value);
				
				$names_string.=$field_name.',';
				$values_string.=$field_value.',';
			}
			
			chop($names_string);
			chop($values_string);
			
			$insert_string='insert into '.$table_name.' ('.$names_string.') VALUES ('.$values_string.')';
			
			$sth =                      
			  $dbh->do( "$insert_string");
			  
			if ( !defined $sth ) {
				
				$global_err="$DBI::errstr";
				return 0;
		 		
		 	} elsif ($sth eq "0E0") {
				
				$warning_flag=1;
			}
		}
	}

	if (!&unlock_tables) {
		
		return 0;
	
	} else {
		
		if ($warning_flag) {
			
			$err_message=q{<b>WARNING</b>: '0 rows affected' happened};
			&write_labeled_message($err_message);
		}
		
		return 1;
	}
}


sub lock_tables {
	
	my ($table_name_list,
	    $table_name,
	    $lock_string
	   );
	   
	$table_name_list='';
	
	foreach $table_name (keys %CHECKED_TABLES) {
		
		$table_name_list.=$table_name.' WRITE ,';
	}
	
	chop ($table_name_list);
	
	$lock_string='LOCK TABLES '.$table_name_list;
	
	if (!defined $dbh->do("$lock_string")) {
		
		$global_err="$DBI::errstr";
		return 0;
	
	} else {
		
		return 1;
	}
}


sub unlock_tables {

	if (!defined $dbh->do("UNLOCK TABLES")) {

		$global_err="$DBI::errstr";
		return 0;
	
	} else {
		
		return 1;
	}
}


sub list_tables {

	if ($mysql_specific) {

		@tables_names = $dbh->func( "_ListTables");
 	
 	} else {
 	
		@tables_names = $dbh->tables;
 	}
 	                  
	return @tables_names+0;
}


#===============================================
#	get_action_info subroutines
#===============================================


sub get_action_info {

	$flag_ok=1;
		
	if (($drop_enabled) and ($CGI_INPUT{drop})) { 

		if (&get_checked_tables) {

			if ($drop_check) {

				print "<center><form action=$thiscgi method=post>";

				$message='Do you really want to delete:';

				foreach $table_name (keys %CHECKED_TABLES) {
					
					$message.="<LI>$table_name";
					
					$tmp_name='checked_table'.$delimitator.$table_name;
					$tmp_value=$table_name;
					print qq{<input type="hidden" name="$tmp_name" value="$tmp_value">\n};
				}

				&write_labeled_message($message);
				print q{<input type="submit" name="refresh" value="Discard"><input type="submit" name="dropok" value="Proceed">};
				print q{</form></center>};

			} else {
			
				$CGI_INPUT{dropok}=1;
				$flag_ok=1;
			}

		} else { 
			
			&write_labeled_message("<b>ERROR:</b> No checked table(s)");
			$flag_ok=0; 
		}
	}
	
	if (($delete_enabled) and ($CGI_INPUT{delete})) { 
		
		if (&verify_checks) {
			
			if ($delete_check) {

				print "<center><form action=$thiscgi method=post>";
			
				&write_labeled_message("Do you really want to delete selected record(s)?");		
				&put_hidden_values;

				print q{<input type="submit" name="refresh" value="Discard"><input type="submit" name="deleteok" value="Proceed">};
				print q{</form></center>};
				
				$flag_ok=0;
				
			} else {
				
				$CGI_INPUT{deleteok}=1;
				$flag_ok=1;
			}
		}
	}

	if (($describe_enabled) and ($CGI_INPUT{describe})) { 

		if (!(&get_checked_tables)) {

			&write_labeled_message("<b>ERROR:</b> No checked table(s)");
			$flag_ok=0;
		}
	}

	if (($select_enabled) and ($CGI_INPUT{select})) { 

		&get_field_names;
		&get_select_params;

		if (!(&get_checked_tables)) {

			&write_labeled_message("<b>ERROR:</b> No checked table(s)");
			$flag_ok=0;
		}
	}
		
	if (($new_enabled) and ($CGI_INPUT{new})) { 

		if (!(&get_checked_tables)) {

			&write_labeled_message("<b>ERROR:</b> No checked table(s)");
			$flag_ok=0;
		}
	}

	if (($prepare_enabled) and ($CGI_INPUT{prepare})) { 

		if (!(&get_checked_tables)) {

			&write_labeled_message("<b>ERROR:</b> No checked table(s)");
			$flag_ok=0;
		}
	}

	if (($selectfields_enabled) and ($CGI_INPUT{selectfields})) { 

		if (&verify_checks) {

			&get_select_params;
			
		} else {
				
			$flag_ok=0;
		}
	}
		
	if (($edititem_enabled) and ($CGI_INPUT{edititem})) { 

		if (!&verify_checks) {
				
			$flag_ok=0;
		}
	}

	if (($insertrecord_enabled) and ($CGI_INPUT{insertrecord})) {
		
		if (&verify_checks) {
			
			&get_field_values;

			if ($insertrecord_check) {
		
				print "<center><form action=$thiscgi method=post>";

				&write_labeled_message("Do you really want to insert record(s)?");

				&put_hidden_values;

				print q{<input type="submit" name="refresh" value="Discard"><input type="submit" name="insertok" value="Proceed">
				</form></center>};
				
				$flag_ok=0;
			
			} else {
				
				$CGI_INPUT{insertok}=1;
				$flag_ok=1;
			
			}
		}
	}

	if (($updaterecord_enabled) and ($CGI_INPUT{updaterecord})) {

		if (&verify_checks) {
			
			&get_field_values;
			
			if ($updaterecord_check) {

				print "<center><form action=$thiscgi method=post>";
	
				&write_labeled_message("Do you really want to update record(s)?");

				&put_hidden_values;

				print q{<input type="submit" name="refresh" value="Discard"><input type="submit" name="updateok" value="Proceed">
				</form></center>};
			
				$flag_ok=0;
				
			} else { 
			
				$CGI_INPUT{updateok}=1;
				$flag_ok=1;
			}
		}
	}
}


sub put_hidden_values {

	my ($table_name,
	    $num,
	    $prim_key,
	    $tmp_name,
	    $tmp_value,
	    $field_name
	    );

	foreach $table_name (keys %CHECKED_ITEMS) {

		$tmp_name='checked_table'.$delimitator.$table_name;
		$tmp_value=$table_name;
		print qq{<input type="hidden" name="$tmp_name" value="$tmp_value">\n};
							
		foreach $prim_key (keys %{$CHECKED_ITEMS{$table_name}}) {
			
			foreach $num (sort numerically keys %{$CHECKED_ITEMS{$table_name}{$prim_key}}) {
								
				$tmp_value=$CHECKED_ITEMS{$table_name}{$prim_key}{$num};
				$tmp_name='checked_item'.$delimitator.$table_name.$delimitator.$prim_key.$delimitator.$num;
				print qq{<input type="hidden" name="$tmp_name" value="$tmp_value">\n};
						
				foreach $field_name (keys %{$FIELD_VALUES{$table_name}{$num}}) {

					$tmp_value=$FIELD_VALUES{$table_name}{$num}{$field_name};
					
					$tmp_value=&html2txt($tmp_value,'nobr');
										
					$tmp_name='field_value'.$delimitator.$num.$delimitator.$table_name.$delimitator.$field_name;
					print qq{<input type="hidden" name="$tmp_name" value="$tmp_value">\n};
				}
			}
		}
	}
}


sub verify_checks {

	my ($flag_err,
	    $dim_hash_tabs,
	    $dim_hash_items,
	    $tabcheck_but,
	    $tabno_with_checked,
	    $dim_hash1,
	    $dim_hash2,
	    $norec_exist,
	    $norec_check,
	    @recerr_noex,
	    @recerr_nocheck,
	    @taberr_no,
	    $tab_string,
	    $err_string
	    );

	$flag_err=0;
	
	&get_checked_tables;
	&get_checked_items;
	($dim_hash_tabs,$dim_hash_items,$tabcheck_but,$tabno_with_checked)=&sync_checked_items(\%CHECKED_TABLES,\%CHECKED_ITEMS);
	&get_field_names;
	
	if ($tabno_with_checked) {
				
		@taberr_no=keys %NO_SYNC_INPUT_HASH2;
		$flag_err=1;
	}
			
	if ($tabcheck_but) {
		
		foreach $key (%NO_SYNC_INPUT_HASH1) {
			$DUP_HASH{$key}=$NO_SYNC_INPUT_HASH1{$key};
		}
				
		($dim_hash1,$dim_hash2,$norec_exist,$norec_check)=&sync_checked_items(\%DUP_HASH,\%FIELD_NAMES);
		
		if ($norec_exist) {
			
			@recerr_noex=keys %NO_SYNC_INPUT_HASH1;
		}
		
		@recerr_nocheck=keys %FIELD_NAMES;
		$flag_err=1;
	}
			
	if (@taberr_no) {
		$tab_string="@taberr_no";
		$tab_string='<li>'.$tab_string;
		$tab_string =~ s/ /<li>/g;
		$err_string="<br><b>ERROR:</b> table(s) no checked with checked item(s):<br>$tab_string<br>";
	}
	if (@recerr_noex) {
		$tab_string="@recerr_noex";
		$tab_string='<li>'.$tab_string;
		$tab_string =~ s/ /<li>/g;
		$err_string.="<br><b>ERROR:</b> table(s) checked without existing item(s):<br>$tab_string<br>";
	}
	if (@recerr_nocheck) {
		$tab_string="@recerr_nocheck";
		$tab_string='<li>'.$tab_string;
		$tab_string =~ s/ /<li>/g;
		$err_string.="<br><b>ERROR:</b> table(s) checked without checked item(s):<br>$tab_string<br>";
	}
			
	if ((!($flag_err)) and (!($dim_hash_tabs))) {
				
		$err_string.='<b>ERROR:</b> No checked record(s) or table(s)';
		$flag_err=1;
	}

	if ($flag_err) {

		&write_labeled_message($err_string);
		return 0;
	
	} else {
		
		return 1;
	}
}


sub get_checked_tables {

	my ($key,
	    $checked_table,
	    $table_name
	    );
	
	foreach $key (keys %CGI_INPUT) {

		($checked_table,$table_name)=split /$delimitator/, $key;
		if ($checked_table eq 'checked_table') {
			$CHECKED_TABLES{$CGI_INPUT{$key}}=$table_name;
			delete $CGI_INPUT{$key};
		}
	}
	
	return %CHECKED_TABLES+0;
}


sub get_checked_items {

	my ($num_of_items ,
	    $checked_item ,
	    $table_name	  ,
	    $rilevant_name,
	    $id_number	  ,
	    $key
	    );

	$num_of_items=0;
	foreach $key (keys %CGI_INPUT) {
		
		($checked_item,$table_name,$rilevant_name,$id_number)=split /$delimitator/, $key;
		
		if ($checked_item eq "checked_item") {
				
			$CHECKED_ITEMS{$table_name}{$rilevant_name}{$id_number}=$CGI_INPUT{$key};
			
			delete $CGI_INPUT{$key};
			$num_of_items++;
		}
	}
	
	return $num_of_items;
}


sub get_field_names {

	my ($num_of_fields,
	    $field_name	  ,
	    $table_name	  ,
	    $id_number	  ,
	    $key
	    );

	$num_of_fields=0;
	foreach $key (keys %CGI_INPUT) {
		
		($field_name,$table_name,$id_number)=split /$delimitator/, $key;
		
		if ($field_name eq "field_name") {
			
			$FIELD_NAMES{$table_name}{$id_number}=$CGI_INPUT{$key};
			delete $CGI_INPUT{$key};
			$num_of_fields++;
		}
	}

	return $num_of_fields;	
}


sub get_select_params {

	my ($num_of_fields,
	    $select_param  ,
	    $table_name	  ,
	    $action_name  ,
	    $key
	    );

	$num_of_fields=0;
	foreach $key (keys %CGI_INPUT) {
		
		($select_param,$action_name,$table_name)=split /$delimitator/, $key;
		
		if ($select_param eq "select_param") {
			
			if ($table_name) {
				
				$SELECT_PARAMS{$action_name}{$table_name}=$CGI_INPUT{$key};
			
			} else {
				
				$SELECT_PARAMS{$action_name}{'all_checked'}=$CGI_INPUT{$key};
			}
			
			delete $CGI_INPUT{$key};
			$num_of_fields++;
		}
	}

	return $num_of_fields;	
}


sub get_field_values {

	my ($num_of_value_fields,
	    $field_value	,
	    $table_name		,
	    $id_number		,
	    $field_name		,
	    $key_field		,
	    $key
	    );

	$num_of_value_fields=0;
	foreach $key (keys %CGI_INPUT) {
		
		($field_value,$id_number,$table_name,$field_name)=split /$delimitator/, $key;
		
		if ($field_value eq 'field_value') {

			if (exists $CHECKED_ITEMS{$table_name}) {
					
				foreach $key_field (keys %{$CHECKED_ITEMS{$table_name}}) {

					if (exists $CHECKED_ITEMS{$table_name}{$key_field}{$id_number}) { 
					
						$FIELD_VALUES{$table_name}{$id_number}{$field_name}=$CGI_INPUT{$key};
						delete $CGI_INPUT{$key};
						$num_of_value_fields++;
					}
				}
			}
		}
	}

	return $num_of_value_fields;	
}


sub sync_checked_items {

	my ($input_hash_ref1	,
  	    $input_hash_ref2	,
	    $keys_equals   	,
	    $index_input_keys1	,
	    $index_input_keys2	,
	    $lower_limit	,
	    $not_synced_end	,
	    $index_synced	,
	    $key		,
	    @input_keys1	,
	    @input_keys2	,
	    @synced_items	,
	    );

	$input_hash_ref1=$_[0];
	$input_hash_ref2=$_[1];
	@input_keys1	=sort keys %{$input_hash_ref1};
	@input_keys2	=sort keys %{$input_hash_ref2};
	@synced_items	=();
	
	$lower_limit=0;
	$keys_equals=0;
	foreach $index_input_keys1 (0 .. $#input_keys1) {
		
		if ($keys_equals) {$lower_limit++; $keys_equals=0;}
		
		foreach $index_input_keys2 ($lower_limit .. $#input_keys2) {

			if ($input_keys1[$index_input_keys1] eq $input_keys2[$index_input_keys2]) { 

				$synced_items[++$#synced_items]=$input_keys1[$index_input_keys1];
				$keys_equals=1;
				last;
			}
		}
	}

	undef %NO_SYNC_INPUT_HASH1;
	undef %NO_SYNC_INPUT_HASH2;
	
	$index_synced=0;
	$not_synced_end=1;
	foreach $key (sort keys %{$input_hash_ref1}) {
			
		if ($not_synced_end) {
						
			if ($synced_items[$index_synced] ne $key) {
			
				$NO_SYNC_INPUT_HASH1{$key}=$key;
				delete ${$input_hash_ref1}{$key};
			
			} else {

				if ($index_synced == $#synced_items) {$not_synced_end=0;} else {$index_synced++;}
			}
		
		} else {

			$NO_SYNC_INPUT_HASH1{$key}=$key;		
			delete ${$input_hash_ref1}{$key};
		}
	}

	$index_synced=0;
	$not_synced_end=1;
	foreach $key (sort keys %{$input_hash_ref2}) {
			
		if ($not_synced_end) {
						
			if ($synced_items[$index_synced] ne $key) {
			
				$NO_SYNC_INPUT_HASH2{$key}=1;
				delete ${$input_hash_ref2}{$key};
			
			} else {

				if ($index_synced == $#synced_items) {$not_synced_end=0;} else {$index_synced++;}
			}
		
		} else {

			$NO_SYNC_INPUT_HASH2{$key}=1;
			delete ${$input_hash_ref2}{$key};
		}
	}

	return %{$input_hash_ref1}+0,%{$input_hash_ref2}+0,%NO_SYNC_INPUT_HASH1+0,%NO_SYNC_INPUT_HASH2+0;
}


sub get_current_select_params {

	my ($table_name,
	    $method,
	    $limit,
	    $where_field,
	    $where_value
	    );
	   
	$table_name=$_[0];
	$method='';
	$limit='';
	$where_field='';
	$where_value='';
	
	if (exists $SELECT_PARAMS{'where'}{$table_name}) {
		
		$where_field=$SELECT_PARAMS{'where_field'}{$table_name};
		$where_value=$dbh->quote($SELECT_PARAMS{'where_value'}{$table_name});		
		$method=$SELECT_PARAMS{'method'}{$table_name};
	}
	
	if (exists $SELECT_PARAMS{'limit'}{$table_name}) {
	
		$limit=$SELECT_PARAMS{'limit'}{$table_name};
	
	} else {
	
		$limit=$SELECT_PARAMS{'limit'}{'all_checked'};
	}
	
	return $limit,$where_field,$where_value,$method;
}


#===============================================
#	perform_action subroutines
#===============================================


sub perform_action {

	if ($insertrecord_enabled and $flag_ok and $CGI_INPUT{insertok}) { 

		&get_checked_tables;
		&get_checked_items;
		&get_field_values;
		
		if (&insert_records) {
			
			$message='Insert operation successfully completed';
			&write_labeled_message($message);
					
		} else {
			
			$error_message="<b>ERROR:</b> insert operation NOT completed<br><b>details:</b> $global_err";
			&write_labeled_message($error_message);
		}
		
		$flag_ok=0;
	}

	if ($updaterecord_enabled and $flag_ok and $CGI_INPUT{updateok}) { 

		&get_checked_tables;
		&get_checked_items;
		&get_field_values;
		
		if (&update_records) {
		
			$message='Update operation successfully completed';
			&write_labeled_message($message);
					
		} else {
			
			$error_message="<b>ERROR:</b> update operation NOT completed<br><b>details:</b> $global_err";
			&write_labeled_message($error_message);
		}
		
		
		$flag_ok=0;
	}

	if ($delete_enabled and $flag_ok and $CGI_INPUT{deleteok}) { 

		&get_checked_tables;
		&get_checked_items;
		
		if (&delete) {

			$message='Delete record(s) operation successfully completed';
			&write_labeled_message($message);
					
		} else {
			
			$error_message="<b>ERROR:</b> delete record(s) operation NOT completed<br><b>details:</b> $global_err";
			&write_labeled_message($error_message);
		}
		
		$flag_ok=0;
	}

	if ($drop_enabled and $flag_ok and $CGI_INPUT{dropok}) { 

		&get_checked_tables;
		
		if (&drop) {

			$message='Drop operation successfully completed';
			&write_labeled_message($message);
					
		} else {
			
			$error_message="<b>ERROR:</b> drop operation NOT completed<br><b>details:</b> $global_err";
			&write_labeled_message($error_message);
		}
		
		$flag_ok=0;
	}

	print qq{
		<br><br>
		<form name="the_script" method="POST" action="$thiscgi">
		<center>
		<table border=0 cellpadding=1 cellspacing=0>
		<tr><td bgcolor="#000000">
   		<table border="0" cellspacing="0" cellpadding="5" BGCOLOR="$table_color">

     		<tr>
      	   	  <td>
			<table border="0" cellspacing="2" cellpadding="2" BGCOLOR="$table_color">
		};

	$current_table_number=1;
	$rilevant_js_obj=0;

	if (!&list_tables) { $empty_db=1; &write_labeled_message("Database_empty");}

	foreach $current_table (@tables_names) {

		print qq{<tr>
			<td align="center" bgcolor="$table_checkb_td_color">
			<FONT FACE="$numb_table_checkb_ff" SIZE="$numb_table_checkb_fs" COLOR="$numb_table_checkb_col">
			};
		
		print $current_table_number;
		
		$tmp_name='checked_table'.$delimitator.$current_table;

		if (($flag_ok) and (exists $CHECKED_TABLES{$current_table}) ) {
			
			print qq{
				</font><input type="checkbox" checked name="$tmp_name" value="$current_table">
				</td>
				};
		} else {

			print qq{
				</font><input type="checkbox" name="$tmp_name" value="$current_table">
				</td>
				};
		}
		
		print qq{
			<td><FONT FACE="$tablename_font_face" SIZE="$tablename_font_size" COLOR="$tablename_font_color">
			$current_table
			</font></td>
			</tr>
			};
	
		$javascript_objects[$current_table_number]->{'object_number'}=$rilevant_js_obj;
		$javascript_objects[$current_table_number]->{'dim_array_obj_num'}=0;
		$rilevant_js_obj++;
			
		if (($describe_enabled) and ($flag_ok) and ($CGI_INPUT{describe})) {
				
			if (exists $CHECKED_TABLES{$current_table}) {

				&main_describe;		
			}	
		}

		if (($select_enabled) and ($flag_ok) and ($CGI_INPUT{select})) {
			
			if (exists $CHECKED_TABLES{$current_table}) {
					
				&main_select;
			}	
		}
		
		if (($prepare_enabled) and ($flag_ok) and ($CGI_INPUT{prepare})) {
			
			if (exists $CHECKED_TABLES{$current_table}) {
					
				&main_prepare;
			}	
		}
		
		if (($new_enabled) and ($flag_ok) and ($CGI_INPUT{new})) {
			
			if (exists $CHECKED_TABLES{$current_table}) {
					
				&main_new;
			}
		}	
	
		if (($selectfields_enabled) and ($flag_ok) and ($CGI_INPUT{selectfields})) {
			
			if (exists $CHECKED_TABLES{$current_table}) {

				&main_selectfields;
			}	
		}
		
		if (($edititem_enabled) and ($flag_ok) and ($CGI_INPUT{edititem})) {
			
			if (exists $CHECKED_TABLES{$current_table}) {						

				&main_edititem;
			}	
		}
		
		$current_table_number++;
	}
	
	print q{	</table>
	   	     </td>
     		  </tr>
     		  <tr>
	           <td>
		};

	if (!$empty_db) {&put_buttons;}

	print q{   </td>
     		  </tr>
	        </table>
	           </td>
     		  </tr>
	        </table>
		</center>
		</form>
		};
		
	if (!$empty_db and $javascript_enabled) {&put_javascript;}
	
	$dbh->disconnect;

}#END__main


sub put_buttons {

	print qq{<table border=0 cellspacing=1 cellpadding=1 BGCOLOR="$table_color"><tr>};
	
	if (($flag_ok) and ($prepare_enabled and $CGI_INPUT{prepare}) and ($select_enabled or $selectfields_enabled)) {
	
		print q{<td colspan=2>};
	
	} else {
		
		print q{<td>};
	}

	print qq{<FONT FACE="$button_font_face" SIZE="$button_font_size" COLOR="$button_font_color">\n};
	
	if ($drop_enabled) {
		
		print q{<input type="submit" name="drop" value="Drop table(s)" onClick="return verify_checked_tables();">};
	}
		
	if ($describe_enabled) {
		
		print q{<input type="submit" name="describe" value="Describe table(s)" onClick="return verify_checked_tables();">};
	}

	if ($prepare_enabled) {
		
		print q{<input type="submit" name="prepare" value="Prepare select" onClick="return verify_checked_tables();">};
	}

	if ($refresh_enabled) {
		
		print q{<input type="submit" name="refresh" value="Refresh table(s) list">};
	}

	if ($flag_ok and ( ($select_enabled and $CGI_INPUT{select}) or ($selectfields_enabled and $CGI_INPUT{selectfields}) )) {

		print q{<input type="submit" name="edititem" value="Edit record(s)" onClick="return (verify_checked_records() && verify_checked_tables());"><input type="submit" name="delete" value="Delete record(s)" onClick="return (verify_checked_records() && verify_checked_tables());">};
	}

	if (($flag_ok) and ($edititem_enabled and $CGI_INPUT{edititem})) {

		print q{<input type="submit" name="updaterecord" value="Update record(s)" onClick="return (verify_checked_records() && verify_checked_tables());">};
	}

	if (($flag_ok) and ($new_enabled and $CGI_INPUT{new})) {

		print q{<input type="submit" name="insertrecord" value="Insert record(s)" onClick="return (verify_checked_records() && verify_checked_tables());">};
	}

	print q{</font></td></tr>};

	if ($new_enabled) {
		
		print q{<tr>};
		
		if (($flag_ok) and ($prepare_enabled and $CGI_INPUT{prepare}) and ($select_enabled or $selectfields_enabled)) {
	
			print q{<td colspan=2>};
	
		} else {
		
			print q{<td>};
		}
		
		print qq{<FONT FACE="$button_font_face" SIZE="$button_font_size" COLOR="$button_font_color"><input type="submit" name="new" value="New record(s)" onClick="return verify_checked_tables();"></font>\n};
		
		print qq{<FONT FACE="$button_font_face" SIZE="$button_font_size" COLOR="$button_font_color">
			<select name="new_elem">
			$new_values
			</select></font>};
		
		print q{</td></tr>};
		
	}

	if ($select_enabled or $selectfields_enabled) {
		
		if (($flag_ok) and ($prepare_enabled and $CGI_INPUT{prepare})) {
		
			print qq{<tr><td><FONT FACE="$button_font_face" SIZE="$button_font_size" COLOR="$button_font_color">\n};
		
		} else {
			
			print qq{<tr><td colspan=2><FONT FACE="$button_font_face" SIZE="$button_font_size" COLOR="$button_font_color">\n};
		}
	}
	
	if ($select_enabled) {
		
		print q{<input type="submit" name="select" value="Select all fields" onClick="return verify_checked_tables();">};
	}
	
	if ($selectfields_enabled and ($prepare_enabled and $CGI_INPUT{prepare})) {
		
		print q{<br><br><input type="submit" name="selectfields" value="Select checked field(s)" onClick="return (verify_checked_records() && verify_checked_tables());">};
	}

	if ($select_enabled or $selectfields_enabled) {
		
		if (($flag_ok) and ($prepare_enabled and $CGI_INPUT{prepare})) {
		
			print q{</font></td><td><table border=0>};
			
			foreach $table_name (sort keys %PREPARE_NAMES) {
			
				print q{<tr>};
				
				print qq{<td><FONT FACE="$button_font_face" SIZE="$button_font_size" COLOR="$button_font_color"> from <b>$table_name</b>
					</font></td>};
				
				$tmp_name1='select_param'.$delimitator.'where'.$delimitator.$table_name;
				
				print qq{<td><FONT FACE="$button_font_face" SIZE="$button_font_size" COLOR="$button_font_color">
					<input type="checkbox" name="$tmp_name1" value=on>&nbsp;where };
				
				$tmp_name1='select_param'.$delimitator.'where_field'.$delimitator.$table_name;
				
				print qq{<select name="$tmp_name1">};
			
				foreach $field_name (@{$PREPARE_NAMES{$table_name}}) {

					print qq{<option>$field_name\n};
				}
			
				print q{</select></font></td>};
				
				$tmp_name1='select_param'.$delimitator.'method'.$delimitator.$table_name;
				$tmp_name2='select_param'.$delimitator.'where_value'.$delimitator.$table_name;
				
				print qq{<td><FONT FACE="$button_font_face" SIZE="$button_font_size" COLOR="$button_font_color">
					<select name="$tmp_name1">
					$select_params
					</select>
					<input type="text" name="$tmp_name2" size="$where_text_size">
					</select></font></td>
					};

				$tmp_name1='select_param'.$delimitator.'limit'.$delimitator.$table_name;

				print qq{<td><FONT FACE="$button_font_face" SIZE="$button_font_size" COLOR="$button_font_color">limit 
					<select name="$tmp_name1">
					$limit_values
					</select></font></td></tr>};
			}
			
			print q{</table></td></tr>};
		
		} else {
			
			print q{</font>};
			
			$tmp_name1='select_param'.$delimitator.'limit'.$delimitator;
			
			print qq{<FONT FACE="$button_font_face" SIZE="$button_font_size" COLOR="$button_font_color">&nbsp;&nbsp;limit 
					<select name="$tmp_name1">
					$limit_values
					</select></font>};
			print q{</td></tr>};
		}
	}
	
	print q{</font></td></tr></table>};
}


sub main_prepare {

	print q{<tr>
			<td>&nbsp;</td>
			<td><table><tr>
		};
					
	($pri_key,$pri_key_index)=&get_pri_key($current_table);
	&prepare($current_table);
				
	$num=0;

	foreach $elem (0..$#{$descarray}) {
					
		if (${$descarray}[$elem] eq $pri_key) {$current_bgcolor=$pri_key_color;} else {$current_bgcolor=$field_color;}

		$item_name='checked_item'.$delimitator.$current_table.$delimitator.$pri_key.$delimitator.$num;
		$item_value=${$descarray}[$elem];
		$field_name='field_name'.$delimitator.$current_table.$delimitator.$num;
		$field_value=${$descarray}[$elem];
		
		if ($selectfields_enabled) {
						
			print qq{
				<input type="hidden" name="$field_name" value="$field_value">
				<td bgcolor="$current_bgcolor">
				<input type="checkbox" name="$item_name" value="$item_value">
				<FONT FACE="$font_face" SIZE="$font_size" COLOR="$font_color">
				};
			
		} else {
		
			print qq{
				<td bgcolor="$current_bgcolor">
				<FONT FACE="$font_face" SIZE="$font_size" COLOR="$font_color">
			};
		}
						
		print ${$descarray}[$elem];
							
		print q{</font></td>};
						
		$javascript_objects[$current_table_number]->{'array_obj_num'}[++$#{$javascript_objects[$current_table_number]->{'array_obj_num'}}]=$rilevant_js_obj+1;
					
		$num++;
		$rilevant_js_obj+=2;
	}
				
	$javascript_objects[$current_table_number]->{'dim_array_obj_num'}=$#{$javascript_objects[$current_table_number]->{'array_obj_num'}}+1;
					
	print q{</tr>};
					
	print q{</table></td></tr>};
}


sub main_new {

	print q{<tr>
			<td>&nbsp;</td>
			<td><table><tr><td>&nbsp</td>
		};
					
	($pri_key,$pri_key_index)=&get_pri_key($current_table);
	&prepare($current_table);
											
	foreach $elem (0 .. $#{$descarray}) {
						
		if (${$descarray}[$elem] eq $pri_key) {$current_bgcolor=$pri_key_color;} else {$current_bgcolor=$field_color;}
						
		$field_name='field_name'.$delimitator.$current_table.$delimitator.$elem;
		$field_value=${$descarray}[$elem];
		
		print qq{
			<input type="hidden" name="$field_name" value="$field_value">
			<td bgcolor="$current_bgcolor">
			<FONT FACE="$font_face" SIZE="$font_size" COLOR="$font_color">
			};
					
		if (${$descarray}[$elem] ne '') {
			
			print ${$descarray}[$elem];
			
		} else {
			
			print '&nbsp;';
		}
							
		print q{</font></td>};
	}

	$rilevant_js_obj+=@{$descarray};
	$num=0;
				
	print q{</tr>};
	
	foreach $new_elem (1 .. $CGI_INPUT{new_elem}) {
	
		print qq{<tr><td bgcolor="$rec_checkb_td_color">
			<FONT FACE="$numb_rec_checkb_ff" SIZE="$numb_rec_checkb_fs" COLOR="$numb_rec_checkb_col">
			};
			
		print $new_elem;

		$check_name='checked_item'.$delimitator.$current_table.$delimitator.$pri_key.$delimitator.$num;
		$check_value=${$descarray}[$elem];
		
		print qq{<input type="checkbox" name="$check_name" value="$check_value">
			</font></td>
			};
		
		$javascript_objects[$current_table_number]->{'array_obj_num'}[++$#{$javascript_objects[$current_table_number]->{'array_obj_num'}}]=$rilevant_js_obj;
		
		foreach $elem (@{$descarray}) {

			print qq{
				<td bgcolor="$table_td_color">
				<FONT FACE="$font_face" SIZE="$font_size" COLOR="$font_color">
				};

			$name='field_value'.$delimitator.$num.$delimitator.$current_table.$delimitator.$elem;
					
			print qq{
				<input type="text" name="$name" value="" size="$input_text_size">
				};
					
			print q{</font></td>};	
		}

		$rilevant_js_obj+=@{$descarray}+1;
		$num++;
														
		print q{</tr>};
	}
	
	print q{</table></td></tr>};
		
	$javascript_objects[$current_table_number]->{'dim_array_obj_num'}=$#{$javascript_objects[$current_table_number]->{'array_obj_num'}}+1;
}


sub main_selectfields {

	$num=0;
						
	print q{<tr>
			<td>&nbsp;</td>
			<td><table><tr><td>&nbsp;</td>
		};

	($pri_key,$pri_key_index)=&get_pri_key($current_table);

	$items_string=$pri_key.',';
	
	foreach $rilevant_name (keys %{$CHECKED_ITEMS{$current_table}}) {
	
		foreach $number (sort numerically keys %{$CHECKED_ITEMS{$current_table}{$rilevant_name}}) {
	
			$items_string.=$CHECKED_ITEMS{$current_table}{$rilevant_name}{$number}.',';		
		}
	}

	chop($items_string);

	$select_string='select '.$items_string.' from '.$current_table;

	($limit,$where_field,$where_value,$method)=&get_current_select_params($current_table);
	
	if ($where_field) {
		$select_string.=' where ('.$where_field.' '.$method.' '.$where_value.')';
	}
	
	$select_string.=' limit '.$limit;

	&select($select_string);
					
	foreach $elem (1..$#{$descarray}) {
						
		if (${$descarray}[$elem] eq $pri_key) {$current_bgcolor=$pri_key_color;} else {$current_bgcolor=$field_color;}
					
		$name='field_name'.$delimitator.$current_table.$delimitator.$num;
		$value=${$descarray}[$elem];
						
		print qq{
			<input type=hidden name="$name" value="$value">
			<td bgcolor="$current_bgcolor">
			<FONT FACE="$font_face" SIZE="$font_size" COLOR="$font_color">
			};
						
		print ${$descarray}[$elem];
							
		print q{</font></td>};
					
		$num++;
	}
					
	print q{</tr>};
				
	$rilevant_js_obj+=$#{$descarray};
	$num=0;

	$countrows=1;					
	foreach $elem (@{$elem_select}) {
						
		$name='checked_item'.$delimitator.$current_table.$delimitator.$pri_key.$delimitator.$num;
		$value=${$elem}[$pri_key_index];


		print qq{<tr><td bgcolor="$rec_checkb_td_color">
			<FONT FACE="$numb_rec_checkb_ff" SIZE="$numb_rec_checkb_fs" COLOR="$numb_rec_checkb_col">
			};
					
		print $countrows;
		
		print qq{	<input type="checkbox" name="$name" value="$value">
				</font>
			    </td>
			};
			
		$countrows++;
							    
		foreach $row_elem_index (1..$#{$elem}) {
						
			print qq{
				<td bgcolor="$table_td_color">
				<FONT FACE="$font_face" SIZE="$font_size" COLOR="$font_color">
				};
						
			if (${$elem}[$row_elem_index] ne '') {
				
				${$elem}[$row_elem_index]=&html2txt(${$elem}[$row_elem_index],'br');
				
				print ${$elem}[$row_elem_index];
			
			} else {
				
				print '&nbsp;';
			}
							
			print q{</font></td>};
		}

		print q{</tr>};

		$javascript_objects[$current_table_number]->{'array_obj_num'}[++$#{$javascript_objects[$current_table_number]->{'array_obj_num'}}]=$rilevant_js_obj;

		$num++;
		$rilevant_js_obj++;
	}

	if ($#{$elem_select} == -1) {
		
		$num=$#{$descarray}+1;
		
		print qq{<tr><td>&nbsp;</td><td align="center" colspan="$num" bgcolor="$table_td_color">
		<FONT FACE="$font_face" SIZE="$font_size" COLOR="$font_color">NOT PRESENT</font></td>};
	}

	$javascript_objects[$current_table_number]->{'dim_array_obj_num'}=$#{$javascript_objects[$current_table_number]->{'array_obj_num'}}+1;
								
	print q{</table></td></tr>};
}


sub main_describe {

	($pri_key,$pri_key_index)=&get_pri_key($current_table);
	&describe($current_table);
						
	print q{<tr>
			<td>&nbsp;</td>
			<td><table>
		};
			
	foreach $elem (@{$descarray_describe}) {
						
		if ($elem eq $pri_key) {$current_bgcolor=$pri_key_color;} else {$current_bgcolor=$field_color;}

		print qq{
			<td bgcolor="$current_bgcolor">
			<FONT FACE="$font_face" SIZE="$font_size" COLOR="$font_color">
			};
								
		print $elem;
							
		print q{
			</font></td>
			};
	}
						
	print q{</tr>};
						
	foreach $elem (@{$elem_describe}) {
							
		print q{<tr>};
							
		foreach $row_elem (@{$elem}) {
	
			print qq{
				<td bgcolor="$table_td_color">
				<FONT FACE="$font_face" SIZE="$font_size" COLOR="$font_color">
				};
							
			if ($row_elem ne '') {
				
				print $row_elem;
			
			} else {
				
				print '&nbsp;';
			}
								
			print q{</font></td>};
		}
							
		print q{</tr>};
	}
					
	print q{</table></td></tr>};
}


sub main_edititem {

	$num=0;
	$item_string='';
					
	print q{<tr>
			<td>&nbsp;</td>
			<td><table><tr><td>&nbsp;</td>
		};
					
	($pri_key,$pri_key_index)=&get_pri_key($current_table);

	foreach $id_num (sort numerically keys %{$FIELD_NAMES{$current_table}}) {
							
		if ($FIELD_NAMES{$current_table}{$id_num} eq $pri_key) {$current_bgcolor=$pri_key_color;} else {$current_bgcolor=$field_color;}

		$field_name='field_name'.$delimitator.$current_table.$delimitator.$num;
		$field_value=${$descarray}[$elem];
		
		print qq{
			<input type="hidden" name="$field_name" value="$field_value">
			<td bgcolor="$current_bgcolor">
			<FONT FACE="$font_face" SIZE="$font_size" COLOR="$font_color">
			};
		
		$item_string.=$FIELD_NAMES{$current_table}{$id_num}.',';
		print $FIELD_NAMES{$current_table}{$id_num};
							
		print q{</font></td>};
		$num++;
	}

	chop($item_string);

	$item_string=$pri_key.','.$item_string;

	$rilevant_js_obj+=$num;
	$num=0;

	$countrows=1;
	foreach $number (sort numerically keys %{$CHECKED_ITEMS{$current_table}{$pri_key}}) {
			
		$value=$CHECKED_ITEMS{$current_table}{$pri_key}{$number};
		
		$quoted_value=$dbh->quote($value);
		$quoted_value=~s/%/\\%/g;
		$quoted_value=~s/_/\\_/g;

		$select_string='select '.$item_string.' from '.$current_table.' where ('.$pri_key.' like '.$quoted_value.')';

		&select($select_string);

		$elem=${$elem_select}[0];
						
		$name='checked_item'.$delimitator.$current_table.$delimitator.$pri_key.$delimitator.$num;
		$value=${$elem}[$pri_key_index];
			
		print qq{<tr><td bgcolor="$rec_checkb_td_color">
			<FONT FACE="$numb_rec_checkb_ff" SIZE="$numb_rec_checkb_fs" COLOR="$numb_rec_checkb_col">
			};
			
		print $countrows;
		
		print qq{	<input type="checkbox" name="$name" value="$value">
				</font>
			    </td>
			};
			
		$countrows++;
							    
		foreach $row_elem_index (1.. $#{$elem}) {
								    
			print qq{
				<td bgcolor="$table_td_color">
				<FONT FACE="$font_face" SIZE="$font_size" COLOR="$font_color">
				\n};
				
			$name='field_value'.$delimitator.$num.$delimitator.$current_table.$delimitator.${$descarray}[$row_elem_index];

			$value=${$elem}[$row_elem_index];
					
			if (($textarea_enabled) and (length($value) >= $max_length4text)) {

				$value=&html2txt($value,'nobr');
				
				print qq{\n<textarea wrap="off" cols="$cols_textarea" rows="$rows_textarea" name="$name">$value</textarea>};
			} else {

				$value=&html2txt($value,'nobr');
			
				print qq{
					<input type=text name="$name" value="$value" size="$input_text_size">
					};
			}
								
			print q{</font></td>};
		}
													
		print q{</tr>};
		
		$javascript_objects[$current_table_number]->{'array_obj_num'}[++$#{$javascript_objects[$current_table_number]->{'array_obj_num'}}]=$rilevant_js_obj;

		$num++;
		$rilevant_js_obj=$rilevant_js_obj+$#{$elem}+1;
	}

	$javascript_objects[$current_table_number]->{'dim_array_obj_num'}=$#{$javascript_objects[$current_table_number]->{'array_obj_num'}}+1;
				
	print q{</table></td></tr>};
}


sub main_select {

	$num=0;
					
	print q{<tr>
			<td>&nbsp;</td>
			<td><table><tr><td>&nbsp;</td>
		};
					
	($pri_key,$pri_key_index)=&get_pri_key($current_table);
					
	foreach $elem (@{$descarray}) {
						
		if ($elem eq $pri_key) {$current_bgcolor=$pri_key_color;} else {$current_bgcolor=$field_color;}
				
		$name='field_name'.$delimitator.$current_table.$delimitator.$num;
		$value=$elem;
						
		print qq{
			<input type="hidden" name="$name" value="$value">
			<td bgcolor="$current_bgcolor">
			<FONT FACE="$font_face" SIZE="$font_size" COLOR="$font_color">
			};
						
		print $elem;
						
		print q{</font></td>};
							
		$num++;
	}
				
	print q{</tr>};

	$rilevant_js_obj+=($#{$descarray}+1);
	$num=0;

	$select_string='select * from '.$current_table;

	($limit,$where_field,$where_value,$method)=&get_current_select_params($current_table);
	
	if ($where_field) {
		$select_string.=' where ('.$where_field.' '.$method.' '.$where_value.')';
	}
	
	$select_string.=' limit '.$limit;

	&select($select_string);
					
	$countrows=1;
	foreach $elem (@{$elem_select}) {
						
		$name='checked_item'.$delimitator.$current_table.$delimitator.$pri_key.$delimitator.$num;
		$value=${$elem}[$pri_key_index];
						
		print qq{<tr><td bgcolor="$rec_checkb_td_color">
			<FONT FACE="$numb_rec_checkb_ff" SIZE="$numb_rec_checkb_fs" COLOR="$numb_rec_checkb_col">
			};
			
		print $countrows;
		
		print qq{	<input type="checkbox" name="$name" value="$value">
				</font>
			    </td>
			};

		$countrows++;

		foreach $row_elem (@{$elem}) {
							
			print qq{
				<td bgcolor="$table_td_color">
				<FONT FACE="$font_face" SIZE="$font_size" COLOR="$font_color">
				};
						
			if ($row_elem ne '') {
				
				$row_elem=&html2txt($row_elem,'br');
				
				print $row_elem;
			
			} else {
				
				print '&nbsp;';
			}
							
			print q{</font></td>};
		}
					
		print q{</tr>};

		$javascript_objects[$current_table_number]->{'array_obj_num'}[++$#{$javascript_objects[$current_table_number]->{'array_obj_num'}}]=$rilevant_js_obj;
		
		$num++;
		$rilevant_js_obj++;
					
		if ($rilevant_js_obj > $max_selected_rows) {last;}
	}
	
	if ($#{$elem_select} == -1) {
		
		$num=$#{$descarray}+1;
		
		print qq{<tr><td>&nbsp;</td><td align="center" colspan="$num" bgcolor="$table_td_color">
			<FONT FACE="$font_face" SIZE="$font_size" COLOR="$font_color">NOT PRESENT</font></td>};
	}
			
	$javascript_objects[$current_table_number]->{'dim_array_obj_num'}=$#{$javascript_objects[$current_table_number]->{'array_obj_num'}}+1;
					
	print q{</table></td></tr>};
}


sub put_javascript {

print <<"EOT";
	
	<script language="JavaScript">
	<!--

function verify_checked_tables () {

	js_tables= new Array($#javascript_objects);
EOT

	foreach $i (1 .. $#javascript_objects) {
		print qq{js_tables[$i]=$javascript_objects[$i]->{'object_number'};\n};
	}
	
print <<"EOT";

	flag_no_check=true;
	for (counter=1;counter<=$#javascript_objects;counter++) {
	
		if (document.the_script.elements[js_tables[counter]].checked) {
			
			flag_no_check=false;
		}
	}
	
	if (flag_no_check) {
		alert("No checked table(s)");	
		return false;
	}

	return true;
}

EOT

	if ($flag_ok and ( $CGI_INPUT{select} or $CGI_INPUT{prepare} or $CGI_INPUT{edititem} or $CGI_INPUT{new} or $CGI_INPUT{selectfields}) ) {

print <<"EOT";

function verify_checked_records () {

	function Info_Table(num,dim) {
		this.object_number=num;
		this.dim_array_obj_num=dim;
		this.array_obj_num=new Array(dim);
	}

	records=new Array($#javascript_objects);
EOT
	
	foreach $i (1 .. $#javascript_objects) {
		print qq{records[$i]=new Info_Table($javascript_objects[$i]->{'object_number'},$javascript_objects[$i]->{'dim_array_obj_num'});\n};
		
		foreach $y (0 .. $#{$javascript_objects[$i]->{'array_obj_num'}}) {
			print qq{records[$i].array_obj_num[$y]=$javascript_objects[$i]->{'array_obj_num'}[$y];\n};
		}
	}
	
print <<"EOT";

	tab_check_rec_nopresent=new Array($#javascript_objects+1);
	tab_check_rec_nocheck=new Array($#javascript_objects+1);
	tab_nocheck_rec_check=new Array($#javascript_objects+1);

	counter_tab_check_rec_nopresent=0;
	counter_tab_check_rec_nocheck=0;
	counter_tab_nocheck_rec_check=0;

	flag_total_err_tab=false;

	for (counter=1;counter<=$#javascript_objects;counter++) {

		if (document.the_script.elements[records[counter].object_number].checked) {

			if (records[counter].dim_array_obj_num == 0) {
				
				tab_check_rec_nopresent[counter_tab_check_rec_nopresent]=counter;
				counter_tab_check_rec_nopresent++;
				flag_total_err_tab=true;
			
			} else {
				
				flag_rec_nocheck=true;
				for (internal_counter=0;internal_counter<records[counter].dim_array_obj_num;internal_counter++) {
				
					if (document.the_script.elements[records[counter].array_obj_num[internal_counter]].checked) {
		
						flag_rec_nocheck=false;
						break;
					}
				}
				
				if (flag_rec_nocheck) {
			
					tab_check_rec_nocheck[counter_tab_check_rec_nocheck]=counter;
					counter_tab_check_rec_nocheck++;
					flag_total_err_tab=true;
				}
			}
			
		} else {

			if (records[counter].dim_array_obj_num != 0) {

				flag_rec_check=false;
				for (internal_counter=0;internal_counter<records[counter].dim_array_obj_num;internal_counter++) {
								
					if (document.the_script.elements[records[counter].array_obj_num[internal_counter]].checked) {
			
						flag_rec_check=true;
						break;
					}
				}
				
				if (flag_rec_check) {

					tab_nocheck_rec_check[counter_tab_nocheck_rec_check]=counter;
					counter_tab_nocheck_rec_check++;
					flag_total_err_tab=true;
				}
			}
		}
	}
	
	if (flag_total_err_tab) {
		
		if (counter_tab_check_rec_nopresent > 0) {

			string_tab_check_rec_nopresent=new String;
			for (counter=0;counter<counter_tab_check_rec_nopresent;counter++) {
				
				string_tab_check_rec_nopresent+=tab_check_rec_nopresent[counter]+" ";
			}
			
			alert("Table(s) "+string_tab_check_rec_nopresent+" checked without existing record(s)");
		}
		
		if (counter_tab_check_rec_nocheck > 0) {

			string_tab_check_rec_nocheck=new String;
			for (counter=0;counter<counter_tab_check_rec_nocheck;counter++) {
				
				string_tab_check_rec_nocheck+=tab_check_rec_nocheck[counter]+" ";
			}

			alert("Table(s) "+string_tab_check_rec_nocheck+" checked without checked record(s)");
		}

		if (counter_tab_nocheck_rec_check > 0) {

			string_tab_nocheck_rec_check=new String;
			for (counter=0;counter<counter_tab_nocheck_rec_check;counter++) {
				
				string_tab_nocheck_rec_check+=tab_nocheck_rec_check[counter]+" ";
			}

			alert("Table(s) "+string_tab_nocheck_rec_check+" with checked record(s) but not checked ");
		}

		return false;

	} else {

		return true;
	}
}
EOT

	} #if
	
	print q{
	//-->
	</script>
	};
}

#####################################################################################################
#	mysqlwdb     Copyright (C) 2000 Andrea Maestrutti     http://www.solution4web.com/mysqlwdb
#####################################################################################################
